/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͕WHID IN/OUTƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "hid_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#include "lib_mcu/util/start_boot.h"

#include "statefunc.h"
#include "menu.h"
#include "main.h"
#include "batt_task.h"

#include "structs.h"
#include "battery.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

volatile U8 cpt_sof=0;
extern   U8 jump_bootloader;
         U8 g_last_joy = 0;

extern volatile ADC_Status_t ADCS;

extern const RID_Lookup_t RID[RID_TABLE_SIZE];

void hid_report_batt_in (void);

//******************************************************************************
// Functions
//******************************************************************************
//! @brief Init for HID task (nothing for battery demo)
//!
//! @param none
//!
//! @return none
//!
void hid_task_init(void)
{
}

//******************************************************************************
// ֐
//******************************************************************************
//! @brief HIDWʐMƂ̓_
//! ̊֐IN/OUT񍐊ǗǗ܂(drɊւĂOUT̂)B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void hid_task (void)
{
	if(!Is_device_enumerated())				// USB HID(ڑF)ꂽ
		return;

	hid_report_batt_in();
}

//******************************************************************************
// ֐
//******************************************************************************
//! @brief ̊֐͓dr񍐂\zνĂ֑܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void hid_report_batt_in (void)
{
	unsigned char i;

	Usb_select_endpoint(EP_HID_IN);
	if(!Is_usb_write_enabled())
		return;								// 񍐑oĂȂB

	// 񍐑o
	Usb_write_byte(2);						// ޮè ޲(t̂߂2)

	if(BattData.Present == TRUE){

		for (i = 0 ; i < RID_TABLE_SIZE; i++) {
			if (ADCS.rawRID >= RID[i].Low) {
				if (ADCS.rawRID <= RID[i].High)
					Usb_write_byte(i + 1);	// VARTAdr`
			}
		}

		switch (CurrentState) {
			case ST_PREQUAL:
			case ST_PREQUAL_CTRL:
			case ST_CCURRENT:
			case ST_CCURRENT_CTRL:
				Usb_write_byte(1);
				break;

			case ST_CVOLTAGE:
			case ST_CVOLTAGE_CTRL:
				Usb_write_byte(2);
				break;

			default:						// ω
				Usb_write_byte(0);
				break;
		}

		Usb_write_byte((U8)(ADCS.VBAT));			// drd޲
		Usb_write_byte((U8)(ADCS.VBAT>>8));			// drd޲
		Usb_write_byte((U8)(ADCS.avgIBAT));			// drd޲
		Usb_write_byte((U8)(ADCS.avgIBAT>>8));		// drd޲
		Usb_write_byte((U8)(BattData.Temperature));	// drx
	}
	else
	{
		Usb_write_byte(0);			// drȂ
		Usb_write_byte(0);			// [dȂ
		Usb_write_byte(0);			// drd޲(=0)
		Usb_write_byte(0);			// drd޲(=0)
		Usb_write_byte(0);			// drd޲(=0)
		Usb_write_byte(0);			// drd޲(=0)
		Usb_write_byte(0);			// drx(=0)
	}
	Usb_ack_in_ready();				// USBް𑗏o
}

//******************************************************************************
// ֐
//******************************************************************************
//! @brief ̊֐USBڰъJn荞ݻٰ݂s(1ms)cpt_sofv
//! 𑝉܂B
//! Ԓx̊ǗɗLpłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void sof_action()
{
	cpt_sof++;
}
